
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Layout_modelsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const layout_models = await db.layout_models.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        model_type: data.model_type
        ||
        null
            ,
            
        deployment_stage: data.deployment_stage
        ||
        null
            ,
            
        model_version: data.model_version
        ||
        null
            ,
            
        artifact_uri: data.artifact_uri
        ||
        null
            ,
            
        trained_at: data.trained_at
        ||
        null
            ,
            
        deployed_at: data.deployed_at
        ||
        null
            ,
            
        rollback_trigger_rate: data.rollback_trigger_rate
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await layout_models.setTenant( data.tenant || null, {
            transaction,
        });
        
        await layout_models.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return layout_models;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const layout_modelsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                model_type: item.model_type
            ||
            null
            ,
            
                deployment_stage: item.deployment_stage
            ||
            null
            ,
            
                model_version: item.model_version
            ||
            null
            ,
            
                artifact_uri: item.artifact_uri
            ||
            null
            ,
            
                trained_at: item.trained_at
            ||
            null
            ,
            
                deployed_at: item.deployed_at
            ||
            null
            ,
            
                rollback_trigger_rate: item.rollback_trigger_rate
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const layout_models = await db.layout_models.bulkCreate(layout_modelsData, { transaction });

        // For each item created, replace relation files
        

        return layout_models;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const layout_models = await db.layout_models.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.model_type !== undefined) updatePayload.model_type = data.model_type;
        
        
        if (data.deployment_stage !== undefined) updatePayload.deployment_stage = data.deployment_stage;
        
        
        if (data.model_version !== undefined) updatePayload.model_version = data.model_version;
        
        
        if (data.artifact_uri !== undefined) updatePayload.artifact_uri = data.artifact_uri;
        
        
        if (data.trained_at !== undefined) updatePayload.trained_at = data.trained_at;
        
        
        if (data.deployed_at !== undefined) updatePayload.deployed_at = data.deployed_at;
        
        
        if (data.rollback_trigger_rate !== undefined) updatePayload.rollback_trigger_rate = data.rollback_trigger_rate;
        
        
        updatePayload.updatedById = currentUser.id;

        await layout_models.update(updatePayload, {transaction});

        
        
        if (data.tenant !== undefined) {
            await layout_models.setTenant(
              
              data.tenant,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await layout_models.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return layout_models;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const layout_models = await db.layout_models.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of layout_models) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of layout_models) {
                await record.destroy({transaction});
            }
        });


        return layout_models;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const layout_models = await db.layout_models.findByPk(id, options);

        await layout_models.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await layout_models.destroy({
            transaction
        });

        return layout_models;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const layout_models = await db.layout_models.findOne(
            { where },
            { transaction },
        );

        if (!layout_models) {
            return layout_models;
        }

        const output = layout_models.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.federated_learning_updates_layout_model = await layout_models.getFederated_learning_updates_layout_model({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.tenant = await layout_models.getTenant({
            transaction
        });
        
        
        output.organizations = await layout_models.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.tenants,
        as: 'tenant',
        
        where: filter.tenant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tenant.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.tenant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'layout_models',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.model_version) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'layout_models',
                        'model_version',
                        filter.model_version,
                    ),
                };
            }
            
            if (filter.artifact_uri) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'layout_models',
                        'artifact_uri',
                        filter.artifact_uri,
                    ),
                };
            }
            

            
            

            
            if (filter.trained_atRange) {
                const [start, end] = filter.trained_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    trained_at: {
                    ...where.trained_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    trained_at: {
                    ...where.trained_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.deployed_atRange) {
                const [start, end] = filter.deployed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    deployed_at: {
                    ...where.deployed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    deployed_at: {
                    ...where.deployed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.rollback_trigger_rateRange) {
                const [start, end] = filter.rollback_trigger_rateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    rollback_trigger_rate: {
                    ...where.rollback_trigger_rate,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    rollback_trigger_rate: {
                    ...where.rollback_trigger_rate,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.model_type) {
                where = {
                    ...where,
                model_type: filter.model_type,
            };
            }
            
            if (filter.deployment_stage) {
                where = {
                    ...where,
                deployment_stage: filter.deployment_stage,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.layout_models.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'layout_models',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.layout_models.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

